; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : C++ Class Interface Demonstration
; File Name : C++ Class Interface Demonstration.pb
; File version: 1.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 01-10-2016
; Last Update : 01-10-2016
; PureBasic code : V5.50
; Platform : Linux x64
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;
; In this example we will create a Module to drive
; a C++ Class Interface directly from a *.so 
; library.
;
; This code is free to be use where ever you like 
; but you use it at your own risk.
;
; The author can in no way be held responsible 
; for data loss, damage or other annoying 
; situations that may occur.
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Time
  
  Declare Initialize()
  Declare Update(Hour.l, Minute.l, Second.l)
  Declare Reset()
  
  CompilerIf #PB_Compiler_Debugger
    Declare Debugging()
  CompilerEndIf
  
EndDeclareModule

Module Time
  
  Interface Time
    
    Update(Hour.l, Minute.l, Second.l)
    SetHour(Hour.l)
    SetMinute(Minute.l)
    SetSecond(Second.l)
    GetHour.l()
    GetMinute.l()
    GetSecond.l()
    Reset()
    
  EndInterface
  
  ImportC "source/bin/Release/libtime.so"
    
    NewTime() As "CreateTimeInterface"
    DeleteTime.l(*Ptr) As "DeleteTimeInterface"

  EndImport 
  
  Global Time.Time
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Initialize Operator <<<<<
  
  Procedure Initialize()
    
    Time = NewTime()
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Update Operator <<<<<
  
  Procedure Update(Hour.l, Minute.l, Second.l)
    
    Time\Update(Hour, Minute, Second)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Reset Operator <<<<<
  
  Procedure Reset()
    
    ; Here we will make sure that our created Time Object is no longer valid
    Time = DeleteTime(Time)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Debogging operator <<<<<
  
  CompilerIf #PB_Compiler_Debugger
    
    Procedure Debugging()
      
      If Time
        Debug Time\GetHour()
        Debug Time\GetMinute()
        Debug Time\GetSecond()
      Else
        Debug "The Time Object is invalid !"
      EndIf
      
    EndProcedure
    
  CompilerEndIf
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Time::Initialize()
  
  Time::Update(21, 06, 30)
  
  CompilerIf #PB_Compiler_Debugger
    Time::Debugging()
  CompilerEndIf
  
  Time::Reset()
  
  CompilerIf #PB_Compiler_Debugger
    Time::Debugging()
  CompilerEndIf
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = ---
; EnableXP
; CompileSourceDirectory